From fda7e44079289d7127de7adfd5d9a40fdb0d3b95 Mon Sep 17 00:00:00 2001
From: Mike Palmiotto <mike.palmiotto@crunchydata.com>
Date: Tue, 17 Mar 2020 18:39:12 +0000
Subject: [PATCH 10/11] Add WalSenderType to subprocess struct

---
 src/backend/postmaster/postmaster.c |  1 +
 src/backend/postmaster/subprocess.c | 11 +++++++++++
 src/include/postmaster/subprocess.h |  1 +
 3 files changed, 13 insertions(+)

diff --git a/src/backend/postmaster/postmaster.c b/src/backend/postmaster/postmaster.c
index d61b8f805b..90fe8ef92a 100644
--- a/src/backend/postmaster/postmaster.c
+++ b/src/backend/postmaster/postmaster.c
@@ -5027,6 +5027,7 @@ SubPostmasterMain(int argc, char *argv[])
 		case PgstatCollectorType:
 		case SysLoggerType:
 		case ClientBackendType:
+		case WalSenderType:
 			MySubprocess->entrypoint(argc, argv);
 			break;
 		default:
diff --git a/src/backend/postmaster/subprocess.c b/src/backend/postmaster/subprocess.c
index 70bc4a4c0c..82861b1d5c 100644
--- a/src/backend/postmaster/subprocess.c
+++ b/src/backend/postmaster/subprocess.c
@@ -150,6 +150,17 @@ static PgSubprocess process_types[] = {
 		.entrypoint = BackendMain,
 		.fork_failure = BackendForkFailure,
 		.postmaster_main = BackendPostmasterMain
+	},
+	{	/* Wal Sender placeholder */
+		.name = "walsender",
+		.desc = "wal sender",
+		.needs_aux_proc = false,
+		.needs_shmem = true,
+		.keep_postmaster_memcontext = true,
+		.fork_prep = BackendPrep,
+		.entrypoint = BackendMain,
+		.fork_failure = BackendForkFailure,
+		.postmaster_main = BackendPostmasterMain
 	}
 };
 
diff --git a/src/include/postmaster/subprocess.h b/src/include/postmaster/subprocess.h
index 06e67efecc..867e1cb499 100644
--- a/src/include/postmaster/subprocess.h
+++ b/src/include/postmaster/subprocess.h
@@ -31,6 +31,7 @@ typedef enum
 	BgWorkerType,
 	ClientBackendType,
 
+	WalSenderType,				/* placeholder for wal sender so it can be identified in pgstat */
 	NUMSUBPROCESSTYPES			/* Must be last! */
 } SubprocessType;
 
-- 
2.21.1

